require 'sketchup.rb'
require 'extensions.rb'
module CURIC
  # Plugin namespace
  module Studio
    PLUGIN            = self
    PLUGIN_NAMESPACE  = 'Curic'.freeze
    PLUGIN_ID         = 'Studio'.freeze
    PLUGIN_NAME       = "#{PLUGIN_NAMESPACE} #{PLUGIN_ID}".freeze
    PLUGIN_VERSION    = '1.0.0'.freeze

    file = __FILE__.dup

    # Account for Ruby encoding bug under Windows.
    file.force_encoding('UTF-8') if file.respond_to?(:force_encoding)

    FILENAMESPACE = File.basename(file, '.*')
    PATH_ROOT     = File.dirname(file).freeze
    PATH          = File.join(PATH_ROOT, FILENAMESPACE).freeze

    unless file_loaded?(__FILE__)
      ex = SketchupExtension.new(PLUGIN_NAME, "#{FILENAMESPACE}/loader")
      ex.version     = PLUGIN_VERSION
      ex.copyright   = 'Curic © 2020–2022'
      ex.creator     = 'Vo Quoc Hai (curic4su@gmail.com)'
      ex.description = 'Package include Curic Plugins'
      Sketchup.register_extension(ex, true)
      PLUGIN_EX = ex
    end
  end
end

file_loaded(__FILE__)
