require 'sketchup.rb'
require 'extensions.rb'
module CURIC
  # Plugin namespace
  module DIO2
    PLUGIN            = self
    PLUGIN_NAMESPACE  = 'Curic'.freeze
    PLUGIN_ID         = 'DIO 2'.freeze
    PLUGIN_NAME       = "#{PLUGIN_NAMESPACE} #{PLUGIN_ID}".freeze
    PLUGIN_VERSION    = '1.1.0'.freeze

    # Resource paths
    FILENAMESPACE = File.basename(__FILE__, '.*')
    PATH_ROOT     = File.dirname(__FILE__).freeze
    PATH          = File.join(PATH_ROOT, FILENAMESPACE).freeze

    unless file_loaded?(__FILE__)
      ex = SketchupExtension.new(PLUGIN_NAME, 'curic_dio2/loader')
      ex.version     = PLUGIN_VERSION
      ex.copyright   = 'Curic © 2020–2022'
      ex.creator     = 'Vo Quoc Hai (curic4su@gmail.com)'
      ex.description = 'DIO (Draw In Object) - Powerful drawing tools'
      Sketchup.register_extension(ex, true)

      PLUGIN_EX = ex
    end
  end
end
file_loaded(__FILE__)
