// ELEMENT.locale(ELEMENT.lang.en)
// Vue app

var app = new Vue({
  el: '#app',
  data: function() {
    return {
      data: {},
      options: {},
      size: [0,0],
      focus: false,
      views: [{
        value: -1,
        label: 'Current View'
      },{
        value: 0,
        label: 'Top'
      },{
        value: 2,
        label: 'Bottom'
      },{
        value: 4,
        label: 'Front'
      },{
        value: 5,
        label: 'Back'
      },{
        value: 6,
        label: 'Left'
      },{
        value: 7,
        label: 'Right'
      }],
      resolutions: {
        0.5: 'Small',
        1: 'Medium',
        1.5: 'High'
      },
      styles: [{
        value: 'current_style',
        label: 'Current Style'
      }, {
        value: 'hidden_line',
        label: 'Hidden Line'
      }, {
        value: 'shaded_with_texture',
        label: 'Shaded With Texture'
      }, {
        value: 'texture',
        label: 'Texture'
      }],
    }
  },
  watch: {
    options: {
      handler: function (val, oldVal) { 
        // console.log('options changed') 
        // console.log(val) 
        // console.log(oldVal)
        // sketchup.optionsChanged(this.options)
      },
      deep: true
    },
    focus(newValue, oldValue) {
      // console.log("focus" + newValue)
      sketchup.mouseFocusChanged(newValue)
    }
  }, 
  methods: {
    optionsChanged(){
      sketchup.optionsChanged(this.options)
    },
    make2D(){
      sketchup.make2D(this.options)
    },
    redraw2D(){
      sketchup.redraw2D(this.options)
    },
    mouseOver(){
      this.focus = true
    },
    mouseLeave(){
      this.focus = false
    },
    imageSize(){
      w = this.size[0]
      h = this.size[1]
      if (w == 0){
        return 'WxH (-x-)'
      }
     return 'WxH (~' + Math.round(w * this.options.resolution) +'x'+ Math.round(h * this.options.resolution) + ')'
    },
  },
  computed:{
  },
  mounted: function() {
    sketchup.ready(window.outerWidth, window.outerHeight);
  },
})

function updateData(options) {
  app.options = options;
}

function updateDemoSize(size) {
  app.size = size;
}

function convexHull(points, pid) {
  hull_points = hull(points, 20);
  // console.log(hull_points);
  sketchup.hull(hull_points, points, pid);
}