$(document).ready(function() {
  $('#filter_cmds').dropdown({
    fullTextSearch: "exact"
  });

  $('.options').change(function () {
    id = $(this).attr("id")
    if ($(this).attr("type") === "checkbox"){
      val = $(this).prop("checked")
    }else{
      val = $(this).val()
    }
    sketchup.change_option(id, val)
  })

  $('#clear_button').click(function(){
    $('#filter_cmds').dropdown('clear');
  });

  $('.ui.checkbox').checkbox();

  // update
  $('#browser_path').click(function(){
    sketchup.browser_path($(this).val());
  });

  $(".view").click(function(){
    var checked = $(this).prop('checked');

    $(".view").each(function() {
      $(this).prop('checked', false)
    })

    $(this).prop('checked', checked);
  });

  $('#to_layout_as_scrapbook').change(function(){
    var as_scrapbook = $(this).prop('checked')
    exportAsScrapbook(as_scrapbook)
    sketchup.as_scrapbook(as_scrapbook);
  });

  $('#from_scene_manager').change(function(){
    var from_scene_manager = $(this).prop('checked')
    modeFromScenes(from_scene_manager)
    sketchup.from_scene_manager(from_scene_manager)
  });

  $('#layout_with_template').change(function(){
    var layout_with_template = $(this).prop('checked')
    modeLayoutWithTemplate(layout_with_template)
    sketchup.layout_with_template(layout_with_template)
  });

  modeFromScenes(false);
  modeLayoutWithTemplate(false)

  sketchup.ready();
}); //$(document).ready

function setSettings(settings) {
  $("#to_layout_paper").val(settings.paper);
  $("#to_layout_scale").val(settings.scale);
  $("#to_layout_not_ortho").val(settings.not_ortho);
  $("#to_layout_offset").val(settings.offset);
  $("#to_layout_preview").prop("checked", settings.preview);
  $("#path").val(settings.path);
  $("#path").prop('title',settings.path);
}

function exportAsScrapbook(as_scrapbook) {
  if (as_scrapbook){
    $("#browser_path").val('Rename');
  }else{
    $("#browser_path").val('Browser');
  };
};

function modeFromScenes(from_scene_manager) {
  if (from_scene_manager){
    $("#mode_select").addClass('disabled');
    $("#filter_cmds").parent().removeClass('disabled');
  }else{
    $("#mode_select").removeClass('disabled');
    $("#filter_cmds").parent().addClass('disabled');
  };
};

function modeLayoutWithTemplate(layout) {
  $("#template_files").prop('disabled', !layout);
};

function applySettings() {
  var settings = {}
  settings.view = $('input[name="view"]:checked').val()
  settings.paper = $("#to_layout_paper").val()
  settings.scale = $("#to_layout_scale").val()
  settings.not_ortho = $("#to_layout_not_ortho").val()
  settings.offset = $("#to_layout_offset").val()
  settings.preview = $("#to_layout_preview").prop("checked");
  settings.as_scrapbook = $("#to_layout_as_scrapbook").prop("checked");
  settings.mode_scene_manager = $("#from_scene_manager").prop("checked");
  settings.from_scene_manager = $("#filter_cmds").val();
  settings.layout_with_template = $("#layout_with_template").prop("checked");
  settings.template_file = $("#template_files").val();
  settings.title_size = $('input[name="title_size"]:checked').val()
  settings.clipping_mask_type = $('input[name="clipping_mask_type"]:checked').val()
  sketchup.apply(settings);
};

function setScenes(data) {
  $('#filter_cmds').dropdown("change values", data.values);

  var x;
  for (x in data.values) {
    item = data.values[x];
    var name = item.name;
    var value = item.value;
    $op = $('<option></option>')
    $op.val(value);
    $op.text(name);
    $('#filter_cmds').append($op)
  };
}

function setTemplates(data) {
  $('#template_files').empty()
  var x;
  for (x in data.files) {
    file = data.files[x];
    $op = $('<option></option>')
    $op.val(file);
    $op.text(file);
    $('#template_files').append($op)
  };
}

function addSelected(data) {
  var from_scene_manager = $('#from_scene_manager').prop("checked")
  if (!from_scene_manager){
    $('#from_scene_manager').prop("checked", true);
    modeFromScenes(true);
  }

  var selected = Object.keys(data)

  $('#filter_cmds').dropdown('clear');
  if (selected.length == 0)
    return;
  else{
    $('#filter_cmds').dropdown('set selected', selected);
  }
}