ELEMENT.locale(ELEMENT.lang.en)

Vue.component('curic-optional', {
  model: {
    prop: 'material',
    event: 'change'
  },
  props: {
    optional: {
      type: String,
    },
    material: {
      type: Object,
    },
    materials: {
      type: Object,
    },
    patterns_cad: {
      type: Array,
    },
    lable: String,
    disabled: Boolean,
  },
  data: function() {
    return {
      propMaterial(material_id, prop){
        var m = this.materials[material_id]
        if (m){
          return m[prop]
        }
        return ''
      },
    }
  },
  template: `
    <el-form label-position="left" label-width="120px" size="mini" :disabled="disabled">
      <el-form-item label="" style="color: #EA212D;" label-width="0">
        <!-- Nêu ko tồn tại giá trị với material[optional] thì value hiển thị sẽ là id-->
        <div class="thumbnail">
          <div class="thumbnail-border">
            <template v-if="materials[material[optional]]">
              <img :src="materials[material[optional]].photo">
            </template>
            <template v-else><img class="thumbnail-none"></template>
          </div>
        </div>

        <el-select 
          filterable 
          size="mini" 
          no-match-text="Missing material!"
          v-model="material[optional]" 
          v-on:change="$emit('change', $event)"
          :style="{width: 'calc(100% - 60px)'}">
          
          <el-option
            v-for="(m, id) in materials"
            :key="m.value"
            :label="m.label"
            :value="m.id">

            <div class="thumbnail">
              <div class="thumbnail-border">
                <img :src="m.photo">
              </div>
            </div>

            {{ m.label }}
          </el-option>
        </el-select>

        <el-button circle size="mini" v-on:click="$emit('get-cmaterial', $event)"  title="Get the current material from Materials dialog">
          <i class="fa fa-reply fa-lg"></i>
        </el-button>
      </el-form-item>

      <!-- Nếu ko có material object tương ứng optional thì sẽ lỗi hiển thị-->
      <!-- Tắt || để giá trị default || disabled ? -->
      <template v-if="materials[material[optional]]">
        <el-form-item label="Texture fit size">
          <el-switch v-model="materials[material[optional]].texture_fit_size"
            v-on:change="$emit('change-material-prop', $event, 'texture_fit_size', materials[material[optional]])">
          </el-switch>
        </el-form-item>

        <el-form-item label="Align with object">
          <el-switch v-model="materials[material[optional]].align_with_object"
            v-on:change="$emit('change-material-prop', $event, 'align_with_object', materials[material[optional]])">
          </el-switch>
        </el-form-item>

        <el-divider></el-divider>
        <div style="margin: 5px;" class="entity-name">Hatch CAD</div>

        <el-form size="mini" label-position="right" label-width="100px">
          <el-form-item label="Pattern">
            <div class="thumbnail">
              <div class="thumbnail-border">
                <template v-if="materials[material[optional]].pattern_cad">
                  <img :src="$root.pathterncadThumbnail(materials[material[optional]].pattern_cad)">
                </template>
                <template v-else><img class="thumbnail-none"></template>
              </div>
            </div>

            <el-select filterable size="mini" v-model="materials[material[optional]].pattern_cad"
              :style="{width: 'calc(100% - 60px)'}"
              v-on:change="$emit('change-material-prop', $event, 'pattern_cad', materials[material[optional]])">
              <el-option
                v-for="p in patterns_cad"
                :key="p.value"
                :label="p.label"
                :value="p.value">
  
                <div class="thumbnail">
                  <div class="thumbnail-border">
                    <img :src="p.thumbnail">
                  </div>
                </div>
  
                {{ p.label }}
              </el-option>
            </el-select>
          </el-form-item>

          <el-form-item label="Scale">
            <el-input-number v-model="materials[material[optional]].pattern_cad_scale"
            :min="0.1" :max="999" :step="10"
            v-on:change="$emit('change-material-prop', $event, 'pattern_cad_scale', materials[material[optional]])"
            ></el-input-number>
          </el-form-item>
        </el-form>

      </template>
    </el-form>
  `,
  methods:{
  },
  computed:{
  }
})

var app = new Vue({
  el: '#app_material',
  data: function() {
    return {
      tabPosition: 'left',
      tabValue: 'multis',
      multimats: [
        {
          value: 'Brick',
          label: 'Brick',
          optional1: '1',
          optional2: '2',
          optional3: '3'
        }
      ],
      materials: {
        '1': {
          id: '1',
          value: 'Brick1',
          label: 'Brick1',
          texture_fit_size: false,
          align_with_object: true,
          pattern_cad: 'ANSI31',
          photo: ''
        },
        '2': {
          id: '2',
          value: 'Brick2',
          label: 'Brick2',
          texture_fit_size: false,
          align_with_object: true,
          pattern_cad: 'ANSI31',
          photo: ''
        },
        '3': {
          id: '3',
          value: 'Brick3',
          label: 'Brick3',
          texture_fit_size: false,
          align_with_object: true,
          pattern_cad: 'ANSI31',
          photo: ''
        },
      },
      patterns_cad:[],
      materialObject(value){
        material = this.materials.find(m => m.value === value)
        if (material === undefined){ material = { optionals: [] } };
        return material
      },
      propMaterial(material_id, prop){
        var m = this.materials[material_id]
        if (m){
          return m[prop]
        }

        return ''
      },
      missingOptionalMaterials(m){
        return !this.materials[m.optional1] || !this.materials[m.optional2] || !this.materials[m.optional3]
      },
      selected_material: null,
      material: {
        value: 'Brick',
        label: 'Brick',
        optional1: '1',
        optional2: '1',
        optional3: '1'
      },
      selected_su_material:null,
      su_material:{
        id: '1',
        value: 'Brick1',
        label: 'Brick1',
        texture_fit_size: false,
        align_with_object: true,
        pattern_cad: 'ANSI31',
        photo: ''
      },
      editName: false,
      tempName: '',
    }
  },
  methods:{
    tabChange(value){
      // change selected_material
      if(app.tabValue === 'multis'){
        sketchup.selected_material(app.selected_material)
      }else{
        sketchup.selected_material(app.selected_su_material)
      }
    },
    materialTool(){
      sketchup.material_tool()
    },
    materialSampleTool(){
      sketchup.material_sample_tool()
    },
    newMaterial(){
      this.$prompt('Enter new name', '', {
        // inputValue: name,
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
      }).then(({ value }) => {
        if (value == null || value == ''){
          this.$message({
            type: 'error',
            message: 'Invalid name!'
          });  
        }else if( this.multimats.find(m => m.label === value) ){
          this.$message({
            type: 'error',
            message: 'Duplicate name!'
          });
        }else{
          sketchup.add_new_multimat(value, {
            onCompleted: function() {
              app.changeMaterial('#[M]-'+value)
            }
          })
        }
      }).catch(() => {
        console.log('Input canceled')
      });
    },
    removeMaterial(){
      this.$confirm('Delete: '+this.material.label+'?', 'Warning', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        type: 'warning'
      }).then(() => {
        // this.$message({
        //   type: 'success',
        //   message: 'Delete completed'
        // });
        sketchup.delete_multimat(this.material)
      }).catch(() => {
        // this.$message({
        //   type: 'info',
        //   message: 'Delete canceled'
        // });          
      });
    },
    changeMaterialName(name){
      this.$prompt('Enter new name', '', {
        inputValue: name,
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
      }).then(({ value }) => {
        if (value == null || value == ''){
          this.$message({
            type: 'error',
            message: 'Invalid name!'
          });  
        }else if( this.multimats.find(m => m.label === value) ){
          this.$message({
            type: 'error',
            message: 'Duplicate name!'
          });
        }else if(value==name){
          console.log('Old name')
        }else{
          sketchup.rename_multimat(this.material, value, {
            onCompleted: function() {
              app.changeMaterial('#[M]-'+value)
            }
          })
        }
      }).catch(() => {
        console.log('Input canceled')
      });
    },
    saveMaterials(){
      sketchup.save_materials()
    },
    loadMaterials(){
      sketchup.load_materials()
    },
    changeMaterial(value){
      if(this.selected_material != value){
        this.selected_material = value;
      };
      this.material = this.multimats.find(m => m.value === value)
      sketchup.selected_material(value)
    },
    changeSuMaterial(value){
      sketchup.selected_material(value)
    },
    changeMultimatOptional(optional){
      console.log(optional)
      sketchup.change_optional_multimat(this.material, optional)
    },
    changeMaterialProp(value, prop, material){
      console.log(value, prop, material)
      sketchup.change_material_prop(value, prop, material)
    },
    getCurentMaterial(optional){
      material = this.material
      sketchup.get_current_material(material, optional, {
        onCompleted: function() {
          if(optional == 'su_material'){
            // app.selected_su_material
          }else{
            console.log('changeMaterial')
            app.changeMaterial(material.value)
          }
        }
      })
    },
    apllyOptional(){
      
    },
    pathterncadThumbnail(pattern_cad){
      pattern_cad = this.patterns_cad.find(p => {
        return p.value == pattern_cad;
      })
      if (pattern_cad){
        return pattern_cad.thumbnail;
      }

      return '';
    }
  },
  computed:{
  },
  mounted: function() {
    sketchup.ready();
  },
})

function updateMultimats(multimats) {
  app.multimats = multimats
  app.material = multimats[0]
  app.selected_material = multimats[0].value

  sketchup.selected_material(app.selected_material)
}

function selectMaterial(material, activeLayersTab) {
  if (material.indexOf('#[M]-') != -1){
    app.material = app.multimats.find(m => m.value === material)
    app.selected_material = material
    tab = 'multis'
  }else{
    app.selected_su_material = material
    tab = 'in model'
  }

  if(activeLayersTab) { app.tabValue=tab };
}

function updateMaterialsData(materials) {
  app.materials = materials
  
  // Array materials 
  app.materials = materials
}

function updatePatternCAD(patterns_cad) {
  app.patterns_cad = patterns_cad
}
