ELEMENT.locale(ELEMENT.lang.en)

Vue.component('cr-layout', {
  props:{
    type: {
      type: String
    }
  },
  template: `
  <span>
    <template v-if="type == 'tabs'">
      <el-tabs type="border-card" tab-position="top">
        <el-tab-pane label="Scene">
          <slot name="placeholder_scene"></slot>
        </el-tab-pane>
        <el-tab-pane label="Layers">
          <slot name="placeholder_layer"></slot>
        </el-tab-pane>
        <el-tab-pane label="Entity">
          <slot name="placeholder_entity"></slot>
        </el-tab-pane>
      </el-tabs>
    </template>

    <template v-else-if="type == 'collapses'">
      <el-collapse>
        <el-collapse-item name="1" title="Scene">
          <slot name="placeholder_scene"></slot>
        </el-collapse-item>
        
        <el-collapse-item name="2" title="Layers">
          <slot name="placeholder_layer"></slot>
        </el-collapse-item>

        <el-collapse-item name="3" title="Entity">
          <slot name="placeholder_entity"></slot>
        </el-collapse-item>
      </el-collapse>
    </template>

  </span>
  `
})

// list fill materiala
Vue.component('curic-material', {
  model: {
    prop: 'material',
    event: 'change'
  },
  props: {
    name:{
      type: String
    },
    materials: {
      type: Object,
    },
    material: {
      type:String,
      default: '1'
    },
    size:{
      type:String,
      default: 'mini'
    },
    disabled: {
      type: Boolean,
      default: false
    },
    placeholder:{
      type: String,
      default: 'Seclect a material'
    },
    clearable: Boolean
  },
  data: function() {
    return {
      // clearable: false,
      materialObject(value){
        m = this.materials[value]
        if (m === undefined){ m = {} };
        return m
      },
      // checkData(){
      //   console.log(material)
      //   console.log(materials)
      //   console.log(materials[material])
      //   console.log(materials[material].optional1.photo)

      //   return 'AAA'
      // }
    }
  },
  template: `
  <span>

      <!-- thumbnail -->
      <template v-if="materialObject(material).is_multimat">

        <div :style="{display: 'inline-block'}">
          <div class="thumbnail">
            <div class="thumbnail-border" title="Optional 1"> 
              <template v-if="materials[material].optional1">
                <img :src="materials[material].optional1.photo">
              </template>
              <template v-else><img class="thumbnail-none"></template>
            </div>
          </div>
          <div class="thumbnail">
            <div class="thumbnail-border" title="Optional 2"> 
              <template v-if="materials[material].optional2">
                <img :src="materials[material].optional2.photo">
              </template>
              <template v-else><img class="thumbnail-none"></template>
             </div>
          </div>
          <div class="thumbnail">
            <div class="thumbnail-border" title="Optional 3"> 
              <template v-if="materials[material].optional3">
                <img :src="materials[material].optional3.photo">
              </template>
              <template v-else><img class="thumbnail-none"></template>
            </div>
          </div>
        </div>
      </template>
      <template v-else-if="materials[material]">
        <div class="thumbnail">
          <div class="thumbnail-border" title="Optionals"> <img :src="materialObject(material).photo"> </div>
        </div>
      </template>

      <div :style="materialsStyle">
        <el-select
          :disabled="disabled"
          :size="size"
          filterable
          :placeholder="placeholder"
          no-data-text="No material"
          :clearable="clearable"
          v-bind:value="material"
          v-on:change="$emit('change', $event)">
  
          <!-- multiple group -->
          <el-option-group
            :key="'multimat'"
            label="Multis">
  
            <el-option
              v-for="(m, key) in materials" v-if="m.is_multimat"
              :key="m.value"
              :label="m.label"
              :value="m.value">
  
              <div class="thumbnail">
                <div class="thumbnail-border"> 
                  <template v-if="m.optional1">
                    <img :src="m.optional1.photo">
                  </template>
                  <template v-else><img class="thumbnail-none"></template>
                </div>
              </div>

              <div class="thumbnail">
                <div class="thumbnail-border"> 
                  <template v-if="m.optional2">
                    <img :src="m.optional2.photo">
                  </template>
                  <template v-else><img class="thumbnail-none"></template>
                </div>
              </div>

              <div class="thumbnail">
                <div class="thumbnail-border"> 
                  <template v-if="m.optional3">
                    <img :src="m.optional3.photo">
                  </template>
                  <template v-else><img class="thumbnail-none"></template>
                </div>
              </div>

              {{ m.label }}
            </el-option>
          </el-option-group>
  
          <!-- single group -->
          <el-option-group
            :key="'single'"
            label="In model">
            <el-option
              v-for="(m, key) in materials" v-if="!m.is_multimat"
              :key="key"
              :label="m.label"
              :value="key">
  
              <div class="thumbnail">
                <div class="thumbnail-border"> <img :src="m.photo"> </div>
              </div>
  
              {{ m.label }}
            </el-option>
          </el-option-group>
  
        </el-select>
      </div>
    </span>
  `,
  computed:{
    checkData(){
      console.log(this.material)
      console.log(this.materials)
      console.log(this.materials[this.material])
      console.log(this.materials[this.material].optional1.photo)
      console.log(this.materials[this.material].optional2.photo)
      console.log(this.materials[this.material].optional3.photo)

      return 'AAA'
    },
    // tinh width of materials select with thumnail
    materialsStyle(){
      thumnail = this.name == "Item material" ? 24 : 0

      if (this.materialObject(this.material).is_multimat){
        thumnails = 3*26 - 1
      }else if(this.materialObject(this.material).photo){
        thumnails = 26
      }else{
        thumnails = thumnail == 24 ? 0 : 4
      }

      style = {
        position: 'absolute',
        display: 'inline-block',
        margin: '0 5px',
        width: 'calc(100% - ' + (thumnails + thumnail + 1) + 'px)'
      }
      return style
    },
  }
})

var app = new Vue({
  el: '#app',
  data: function() {
    return {
      tabPosition: 'left',
      tabValue: 'scene',
      scales: [
        {
          value: 'Custom',
          label: 'Custom'
        },
        {
          value: '1/10',
          label: '1/10'
        },
        {
          value: '1/20',
          label: '1/20'
        },
        {
          value: '1/50',
          label: '1/50'
        },
        {
          value: '1/100',
          label: '1/100'
        },
        {
          value: '1/200',
          label: '1/200'
        },
        {
          value: '1/500',
          label: '1/500'
        },
      ],
      materials: {
        '1':{
          is_multimat: false
        }
      },
      // multimat_materials: [],
      // single_materials: [],
      // data_materials:{
      //   materials:[],
      //   multimat:[],
      //   single:[]
      // },
      materialObject(value){
        m = this.materials[value]
        if (m === undefined){ m = {} };
        return m
      },
      missingItemMaterials(layer_name){
        item_object = this.su_items.find(l => l.value === layer_name);
        if (item_object && item_object.material){
          return !this.materials[item_object.material]
        }

        return false
      },
      linewidths:[
        {
          value: "None",
          label: "None"
        },
        {
          value: "0.05mm",
          label: "0.05mm"
        },
        {
          value: "0.09mm",
          label: "0.09mm"
        },
        {
          value: "0.1mm",
          label: "0.1mm"
        },
        {
          value: "0.13mm",
          label: "0.13mm"
        },
        {
          value: "0.18mm",
          label: "0.18mm"
        },
        {
          value: "0.2mm",
          label: "0.2mm"
        },
        {
          value: "0.25mm",
          label: "0.25mm"
        },
        {
          value: "0.3mm",
          label: "0.3mm"
        },
        {
          value: "0.35mm",
          label: "0.35mm"
        },
        {
          value: "0.4mm",
          label: "0.4mm"
        },
        {
          value: "0.5mm",
          label: "0.5mm"
        },
        {
          value: "0.7mm",
          label: "0.7mm"
        },
        {
          value: "0.8mm",
          label: "0.8mm"
        },
        {
          value: "0.9mm",
          label: "0.9mm"
        },
        {
          value: "1mm",
          label: "1mm"
        },
        {
          value: "2mm",
          label: "2mm"
        }
        ],
      
      scene: {
        // name: 'Scene 1',
        // is_section: true,
        // active_cut: true,
        // order: 'by_layer',
        // scale: '1/100',
        // scale_custom: 75,
        material: '1',
        // clipping: true,
        // clipping_alpha: 50,
        // clipping_distance: '1000mm',
        // override: false,
        // linesnap: true,
        // fit_view: true
      },
      su_items:[
        // {
        //   value: 'm_concrete',
        //   label: 'm_concrete'
        // },
        // {
        //   value: 'm_brick',
        //   label: 'm_brick'
        // }
      ],
      selected_item: null,
      item_object: {
        // material: "#[M]-[Curic]Concrete",
        // linewidth: '0.3mm',
        // zindex: 5,
        // multimat: 100
      },
      define_item: {},
      dialogNewItemVisible: false,
      more_item_option: false,
      entity:{
        title: "No selection",
        make_fill: false,
      }
    }
  },
  methods: {
    
    changeM(value){
      console.log(this.material)
      console.log(value)
    },
    // toolbar
    newSection(){
      sketchup.new_section();
    },
    removeSection(){
      sketchup.remove_section();
    },
    copySection(){
      sketchup.copy_section();
    },
    pasteSection(){
      sketchup.paste_section();
    },
    duplicateSection(){
      sketchup.duplicate_section();
    },
    alignSection(){
      sketchup.align_section();
    },
    fnfSection(){
      sketchup.fnf_section();
    },
    settingSection(){
      sketchup.setting_section();
    },
    exportSection(){
      sketchup.export_section();
    },
    toolbarClick(cmd){
      console.log(cmd)
    },

    // active cut
    changeActiveCut(value){
      sketchup.change_active_cut(value);
    },
    // scale
    sceneScaleChange(value) {
      this.apllyScene()
    },

    // material
    sceneMatChange(value) {
      material = this.materials[value]
      this.apllyScene()
    },

    // clipping
    changeClipping(value){
      sketchup.change_clipping(value);
    },
    changeClippingType(value){
      sketchup.change_clipping_type(value);
    },
    changeClippingAlpha(value){
      sketchup.change_clipping_alpha(value);
    },
    changeClippingDistance(value){
      sketchup.change_clipping_distance(value);
    },
    
    // fit view
    changeFitView(value){
      sketchup.change_fit_view(value);
    },

    apllyScene(value, update){
      sketchup.apply_scene(this.scene, update);
    },

    // Item
    selectedItemChange(value) {
      this.item_object = this.su_items.find(l => l.value === value);
    },
    changeItemMakeFill(value){
      sketchup.make_fill(this.item_object, value)
    },
    uniqueOnScene(value){
      sketchup.unique_item_on_scene(this.item_object, value)
    },
    editItems(){
      sketchup.edit_items(this.itemType);
    },
    apllyItem(){
      sketchup.aplly_item(this.item_object);
    },
    defineNewItem() {
      sketchup.define_item(this.define_item);
      this.dialogNewItemVisible = false;
    },

    // Entity
    changeInstanceMakeFill(value){
      sketchup.change_instance_makefill(value)
    },
    changeSectionPlaneInfo(){
      sketchup.change_sectionplane_info(this.entity)
    },
    selectSectionPlaneScene(value){
      sketchup.selected_page_of_section(value)
    },
    explodeEntity(value){
      sketchup.explode_entity();
    },
    updateEntity(value){
      sketchup.update_entity();
    },
    accept(value){
      var data = {}
      data.plant = this.plant
      data.plant_group = this.plant_group
      sketchup.accept(data);
    },
    sketchup: function(value){
      sketchup.say(value)
    },
  },
  computed:{
    itemType(){
      if(this.scene.order === 'by_solid'){
        return 'Materials' 
      }
      return 'Layers'
    },
    disabledMaterialItem(){
      if(this.item_object.use_axes && 
        this.item_object.material_x && this.item_object.material_x != '' &&
        this.item_object.material_y && this.item_object.material_y != '' &&
        this.item_object.material_z && this.item_object.material_z != ''){
          return true
        }
      return false
    },
    showMoreItemOption(){
      return this.more_item_option || this.item_object.use_axes
    },
    linewidthThumbnail(){
      style = {
                height: (!this.item_object.linewidth || this.item_object.linewidth === "None") ? '0' : ((Number(this.item_object.linewidth.replace('mm', '')) < 0.3 ) ? '1px' : this.item_object.linewidth),
                width: '100%',
                background: 'black',
                position: 'absolute',
                bottom: 'calc(11px - '+this.item_object.linewidth+'/2)'
              }
      return style
    },
    linewidthsStyle(){
      style = {
                display: 'inline-block',
                width: 'calc(100%'+(this.item_object.linewidth != 'None' ? ' - 26px': '')+')'
              }
      return style
    }
  },
  mounted: function() {
    sketchup.ready();
  },
})

function updateData(data) {
  app.scene = data;
}

// function updateMaterials(materials, multimat, single) {
//   app.materials = materials;
//   app.multimat_materials = multimat;
//   app.single_materials = single;

//   // tách nhóm để tạo nhóm trên list
//   app.data_materials = {
//     materials: materials,
//     multimat: multimat,
//     single: single
//   }
// }

function updateMaterials(materials) {
  app.materials = materials;
}

function updateMaterialsData(multimats, su_materials) {
  // su_materials là JSON với key là material_id và value là object material values
  app.su_materials = su_materials
  
  // multimats là Array chứa các multimat object có các optional property
  // khi lấy dữ liệu của 1 optional là chỉ cần gọi su_materials[optional]
  app.multimats = multimats

  cr_materials = []
  for (let i = 0; i < multimats.length; i++) {
    const cr_mat = multimats[i];
    m = {
      label: cr_mat.label,
      value: cr_mat.value,
      optionals: [
        su_materials[cr_mat.optional1].photo,
        su_materials[cr_mat.optional2].photo,
        su_materials[cr_mat.optional3].photo,
      ]
    }
    cr_materials.push(m)
  }
  // để render list <select> materials cần 1 array chứa các multimat & su_material Object
  // Phân nhóm cr_material<multimat> và su_material
  
  for(var id in materials) {
    materials.push(su_materials[id])
  }

  materials = {
    cr_material: cr_material,
    su_material: su_material
  }
  
  
  app.materials = materials
}

function updateSectionItems(su_items) {
  // Chọn item_object hiện tại nếu ko ta chọn item_object thứ nhất
  selected_item = app.selected_item;
  app.su_items = su_items;
  item_object = app.su_items.find(l => l.value === selected_item);
  if (item_object){
    selectLayer(item_object);
  }else{
    selectLayer(su_items[0]);
  }
}

function selectLayer(item_object, activeLayersTab) {
  app.item_object = item_object;
  app.selected_item = app.item_object ? item_object.value : '';
  if(activeLayersTab) { app.tabValue='su_items' };
}

function defineNewItem(item) {
  app.define_item = item
  app.dialogNewItemVisible = true;
}

function updateEntity(data) {
  app.entity = data;
}